<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Untitled Document</title>
</head>

<body>
<?php

// Set the debug flag to be used mainly for outputting info to the browser.
$DEBUG = false;

// Variable $datastring contains the Medweb data by modality for the year 2011.
// Each row is a Site, identified by letters A through X.
// Each column is a month, Jan - Dec.
// The last row and column are totals.

$datevar = date('d_m_y_h_i_s');  // I use this in the prefix if I want to keep all the files I create
$timevar = date('h_i_s');  // I use this in the prefix for daily development

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// Open Antz CSV Node file for writing.
// This is the main file used with Antz. It contains the essential data, but does not contain tags (labels),
// or channel data.

// I create a prefix variable which I also use with the .bat file.
// I use the datevar variable if I want to avoid overwriting previously generated csv and bat files
$outputfileprefix = "simple3dgrid_level0_5_".$datevar;  
$outputfile = "ANTZ0001".$outputfileprefix.".CSV"; 
@$fpout1 = fopen($outputfile, 'w');

if (!$fpout1) {
	echo "<p><strong>Antz CSV output file cannot be opened for writing.</strong></p>";
	exit;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// Open Antz Tag file for writing label info.
// The I key is used to display this information in Antz.
// There is currently a limitation of this feature that requires the file to be saved as ANTz0001.CSV in the
// antzcsv folder. In this case we are going to create the tag file but we are saving the Node file in 
// the antzcsv folder. We can move it and rename it manually later. Then we can use the 1 key to load it
// into Antz.

$tagfile = "antzcsv/ANTzTag0001.CSV";
@$fptag1 = fopen($tagfile, 'w');

if (!$fptag1) {
	echo "<p><strong>Antz Tag file cannot be opened for writing.</strong></p>";
	exit;
}

$tagstring = "id,record,id,table_id,title,description\n";  // Header row
fwrite($fptag1, $tagstring);  // Write the header row to the Tag file

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// Open Antz Bat file for writing.
// I like to create a .bat file automatically since it makes it easy for Dave.
// A .bat file must be used in order for the dbquery feature to work. 
// In this case we're not using db query with the U key, but it's still easier to open the file with a .bat

$batfile = $outputfileprefix.".bat";
@$fpbat1 = fopen($batfile, 'w');

if (!$fpbat1) {
	echo "<p><strong>Bat file cannot be opened for writing.</strong></p>";
	exit;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// This string is written to the .bat file and allows the user to launch Antz and load the CSV file automatically. 
$batstring = "antz_b.exe $outputfile";
fwrite($fpbat1, $batstring);
fclose($fpbat1);

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// Various color tables of various sizes

$colortable[0] = "255,0,0"; //red
$colortable[1] = "0,255,0"; //green
$colortable[2] = "0,0,255"; //blue
$colortable[3] = "0,255,255"; //cyan
$colortable[4] = "255,0,255"; //magenta
$colortable[5] = "255,255,0"; //yellow
$colortable[6] = "255,153,0"; //orange
$colortable[7] = "255,0,102"; //hot pink
$colortable[8] = "0,255,102"; //dark cyan
$colortable[9] = "0,155,0";  //dark green
$colortable[10] = "128,0,128"; //deep purple
$colortable[11] = "0,153,255"; //turquoise
$colortable[12] = "204,102,0"; //brown
$colortable[13] = "153,0,0"; //deep red
$colortable[14] = "100,100,100";  //dark gray
$colortable[15] = "0,125,125";  //dark turquoise
$colortable[16] = "190,190,190";  //light gray
$colortable[17] = "100,255,100";  //light green
$colortable[18] = "100,100,255";  //light blue
$colortable[19] = "255,180,255";  //light purple
$colortable[20] = "255,200,0";  //gold
$colortable[21] = "0,100,120";  //??
$colortable[22] = "40,100,180"; //??
$colortable[23] = "80,100,220"; //??
$colortable[24] = "255,255,255";  //white

$firecolortable[0] = "255,0,0";   // red
$firecolortable[1] = "255,20,0"; 
$firecolortable[2] = "255,40,0"; 
$firecolortable[3] = "255,60,0"; 
$firecolortable[4] = "255,80,0"; 
$firecolortable[5] = "255,100,0"; 
$firecolortable[6] = "255,120,0"; 
$firecolortable[7] = "255,160,0"; 
$firecolortable[8] = "255,200,0"; 
$firecolortable[9] = "255,220,0";  
$firecolortable[10] = "255,255,0";  // yellow
$firecolortable[11] = "255,255,0"; 
$firecolortable[12] = "255,255,50"; 
$firecolortable[13] = "255,255,100"; 
$firecolortable[14] = "255,255,150";  
$firecolortable[15] = "255,255,200";  
$firecolortable[16] = "255,255,255";  // white

$rainbowcolortable[0] = "255,0,0"; //red
$rainbowcolortable[1] = "255,50,0"; 
$rainbowcolortable[2] = "255,100,0"; 
$rainbowcolortable[3] = "255,150,0"; //orange
$rainbowcolortable[4] = "255,200,0"; 
$rainbowcolortable[5] = "255,255,0"; //yellow
$rainbowcolortable[6] = "200,255,0"; 
$rainbowcolortable[7] = "150,255,0"; 
$rainbowcolortable[8] = "100,255,0"; 
$rainbowcolortable[9] = "50,255,0";  
$rainbowcolortable[10] = "0,255,0"; //green
$rainbowcolortable[11] = "0,200,60"; 
$rainbowcolortable[12] = "0,100,120"; 
$rainbowcolortable[13] = "0,50,180"; 
$rainbowcolortable[14] = "0,0,255";  //blue
$rainbowcolortable[15] = "100,0,255";  
$rainbowcolortable[16] = "255,0,255";  //magenta

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// Create Node State File. 
///////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// Initialize node parameters.
// This is the list of variables representing all columns in the CSV Node file.
// The values are typical for initial conditions in a simple Antz space.
// This should probably be a key->value array, but I prefer this approach for simplicity.

$id = 0;
$type = 5;
$data = $id;
$selected = 0;
$parent_id = 0;
$branch_level = 1;
$child_id = $id;
$child_index = 0;
$child_count = 0;
$ch_input_id = 0;
$ch_output_id = 0;
$ch_last_updated = 0;
$average = 0;
$interval = 1;
$aux_a_x = 0;
$aux_a_y = 0;
$aux_a_z = 0;
$aux_b_x = 0;
$aux_b_y = 0;
$aux_b_z = 0;
$color_shift = 0;
$rotate_vec_x = 0;
$rotate_vec_y = 0;
$rotate_vec_z = 0;
$rotate_vec_s = 1;
$scale_x = 0;
$scale_y = 0;
$scale_z = 0;
$translate_x = 0;
$translate_y = 0;
$translate_z = 0;
$tag_offset_x = 0;
$tag_offset_y = 1.5;
$tag_offset_z = 0;
$rotate_rate_x = 0;
$rotate_rate_y = 0;
$rotate_rate_z = 0;
$rotate_x = 0;
$rotate_y = 0;
$rotate_z = 0;
$scale_rate_x = 0;
$scale_rate_y = 0;
$scale_rate_z = 0;
$translate_rate_x = 0;
$translate_rate_y = 0;
$translate_rate_z = 0;
$translate_vec_x = 0;
$translate_vec_y = 0;
$translate_vec_z = 0;
$shader = 0;
$geometry = 3;
$line_width = 1;
$point_size = 0;
$ratio = 0.1;
$color_index = 0;
$color_r = 110;
$color_g = 110;
$color_b = 110;
$color_a = 255;
$color_fade = 0;
$texture_id = 0;
$hide = 0;
$freeze = 0;
$topo = 2;
$facet = 0;
$auto_zoom_x = 0;
$auto_zoom_y = 0;
$auto_zoom_z = 0;
$trigger_hi_x = 0;
$trigger_hi_y = 0;
$trigger_hi_z = 0;
$trigger_lo_x = 0;
$trigger_lo_y = 0;
$trigger_lo_z = 1;
$set_hi_x = 0;
$set_hi_y = 0;
$set_hi_z = 0;
$set_lo_x = 0;
$set_lo_y = 0;
$set_lo_z = 0;
$proximity_x = 0;
$proximity_y = 0;
$proximity_z = 0;
$proximity_mode_x = 0;
$proximity_mode_y = 0;
$proximity_mode_z = 0;
$segments_x = 16;
$segments_y = 16;
$segments_z = 0;
$tag_mode = 0;
$format_id = 0;
$table_id = 0;
$record_id = $id;
$size = 420;

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// Output the first few strings hard-coded for the world, grid, camera, etc.
// The following seven rows of data correspond to what you would get if you launched Antz and immediately
// hit the K key to 'keep' the file. This is typical of the default Antz space, grid, etc. You can manually
// alter it as needed.

$outputstring = "id,type,data,selected,parent_id,branch_level,child_id,child_index,child_count,ch_input_id,ch_output_id,ch_last_updated,average,interval,aux_a_x,aux_a_y,aux_a_z,aux_b_x,aux_b_y,aux_b_z,color_shift,rotate_vec_x,rotate_vec_y,rotate_vec_z,rotate_vec_s,scale_x,scale_y,scale_z,translate_x,translate_y,translate_z,tag_offset_x,tag_offset_y,tag_offset_z,rotate_rate_x,rotate_rate_y,rotate_rate_z,rotate_x,rotate_y,rotate_z,scale_rate_x,scale_rate_y,scale_rate_z,translate_rate_x,translate_rate_y,translate_rate_z,translate_vec_x,translate_vec_y,translate_vec_z,shader,geometry,line_width,point_size,ratio,color_index,color_r,color_g,color_b,color_a,color_fade,texture_id,hide,freeze,topo,facet,auto_zoom_x,auto_zoom_y,auto_zoom_z,trigger_hi_x,trigger_hi_y,trigger_hi_z,trigger_lo_x,trigger_lo_y,trigger_lo_z,set_hi_x,set_hi_y,set_hi_z,set_lo_x,set_lo_y,set_lo_z,proximity_x,proximity_y,proximity_z,proximity_mode_x,proximity_mode_y,proximity_mode_z,segments_x,segments_y,segments_z,tag_mode,format_id,table_id,record_id,size\n";
fwrite($fpout1, $outputstring);
$outputstring = "1,0,1,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0.100000,0,50,101,101,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,420\n";
fwrite($fpout1, $outputstring);
$outputstring = "2,1,2,0,0,0,2,2,3,0,0,0,0,1,0,0,0,0,0,0,0,0,0.838780,0.011714,-0.544345,1,1,1,13.487717,-1.208139,76.314270,0,0,1,0,0,0,57.020073,89.199921,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0.100000,0,50,101,101,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103.140678,0,0,0,0,0,16,16,0,0,0,0,0,420\n";
fwrite($fpout1, $outputstring);
$outputstring = "3,1,3,0,2,1,3,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,-1,1,1,1,-0.500000,0,571.750000,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0.100000,0,50,101,101,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,420\n";
fwrite($fpout1, $outputstring);
$outputstring = "4,1,4,0,2,1,4,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,-0,1,1,1,0,-90,7,0,0,1,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0.100000,0,50,101,101,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,420\n";
fwrite($fpout1, $outputstring);
$outputstring = "5,1,5,0,2,1,5,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,-1,-0,-0,1,1,1,85,0,7,0,0,1,0,0,0,90,270,0,0,0,0,0,0,0,-0,0,0,0,0,1,0,0.100000,0,50,101,101,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,16,0,0,0,0,0,420\n";
fwrite($fpout1, $outputstring);
$outputstring = "6,6,6,0,0,0,6,1,2,0,0,0,0,1,0,0,0,0,0,0,010000.360043,0.193890,10000010000000000000000,0,100.100000,3,0,0,255,150,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0000000000,0,0,12,12,0,0,0,0,0,420\n";
fwrite($fpout1, $outputstring);

// Below are the number of objects I want to include at each "level". 
// However, my "level" corresponds to the level of my 'for' loops, NOT the Antz Branch Level. 
// Sorry if this causes confusion. 
// Therefore, my level0 includes both the root pin object at Branch Level 0 and the toroid at
// Branch Level 1. My level1 includes the single object in Branch Level 2.
// Shane designed Branch Levels 0 and 1 in a weird way such that if the BL 0 object is select
// and you hit the N key for a new subobject, it creates a new antz, not a second toroid. 
// Try this yourself. That's why I create BL 0 and BL 1 objects in the same level0 'for' loop.

$numx = 3;
$numy = 3;
$numz = 3;

$numlevel0toroids = $numx * $numy * $numz; // I am not actually going to use this variable except to echo below
$numlevel1toroids = 3;
$numlevel2toroids = 3;
$numlevel3toroids = 3;   
$numlevel4toroids = 3;  
$numlevel5toroids = 3;  

echo "numlevel0toroids: $numlevel0toroids<br />"; 
echo "numlevel1toroids: $numlevel1toroids<br />"; 
echo "numlevel2toroids: $numlevel2toroids<br />"; 
echo "numlevel3toroids: $numlevel3toroids<br />"; 
echo "numlevel4toroids: $numlevel4toroids<br />"; 

$id = 6; // Set $id equal to the number of rows of data already written to the Node file, not including the header row
$taginc = 0; // Initialize an incremental variable for the Tag file corresponding to each row of Tag data.

// The 3 for loops for i, j, and k make it easy to distribute objects in xyz space. Note how the translate parameters 
// are functions of i, j, and k.
for ($i = 0; $i < $numx; $i++) {  
	for ($j = 0; $j < $numy; $j++) {
		for ($k = 0; $k < $numz; $k++) {
			$id++;
			$data = $id;
			$parent_id = 0;
			$branch_level = 0;
			$child_id = $id;
			$child_count = 1;
			$translate_x = 10*$i;
			$translate_y = 10*$j;
			$translate_z = 10*$k;
			$scale_x = 1;
			$scale_y = $scale_x;
			$scale_z = $scale_x;
			$colorvar = $firecolortable[$j];
			$color_a = 255; // Not needed since 255 is the default, but try making it smaller
			$geometry = 16;  // A pin is the usual default object for BL 0
			$topo = 5;  // A topo of 5 is the usual default for BL 0
			$record_id = $id;
			//if ($DEBUG) echo "eventid[$i] = $eventid[$i] record_id = $record_id<br />";
			$outputstring = "$id, $type, $data, $selected, $parent_id, $branch_level, $child_id, $child_index, $child_count, $ch_input_id, $ch_output_id, $ch_last_updated, $average, $interval, $aux_a_x, $aux_a_y, $aux_a_z, $aux_b_x, $aux_b_y, $aux_b_z, $color_shift, $rotate_vec_x, $rotate_vec_y, $rotate_vec_z, $rotate_vec_s, $scale_x, $scale_y, $scale_z, $translate_x, $translate_y, $translate_z, $tag_offset_x, $tag_offset_y, $tag_offset_z, $rotate_rate_x, $rotate_rate_y, $rotate_rate_z, $rotate_x, $rotate_y, $rotate_z, $scale_rate_x, $scale_rate_y, $scale_rate_z, $translate_rate_x, $translate_rate_y, $translate_rate_z, $translate_vec_x, $translate_vec_y, $translate_vec_z, $shader, $geometry, $line_width, $point_size, $ratio, $color_index, $colorvar, $color_a, $color_fade, $texture_id, $hide, $freeze, $topo, $facet, $auto_zoom_x, $auto_zoom_y, $auto_zoom_z, $trigger_hi_x, $trigger_hi_y, $trigger_hi_z, $trigger_lo_x, $trigger_lo_y, $trigger_lo_z, $set_hi_x, $set_hi_y, $set_hi_z, $set_lo_x, $set_lo_y, $set_lo_z, $proximity_x, $proximity_y, $proximity_z, $proximity_mode_x, $proximity_mode_y, $proximity_mode_z, $segments_x, $segments_y, $segments_z, $tag_mode, $format_id, $table_id, $record_id, $size\n";
			//echo $outputstring."<br />\n";
			fwrite($fpout1, $outputstring);
			$tagtext = "i: ".$i." j: ".$j." k: ".$k;
			$tagstring = "$taginc,$record_id,0,\"$tagtext\",\"\"\n";
			$taginc++;
			fwrite($fptag1, $tagstring);
			
			$id++;
			$level0object1id = $id; // This variable is needed for level 1 object parent_id before id gets incremented
			$data = $id;
			$parent_id = $id-1; // BL 1 objects always get their BL 0 as parent
			$branch_level = 1; 
			$child_id = $id;
			$child_count = $numlevel1toroids;
			$scale_x = 1;
			$scale_y = 1;
			$scale_z = 1;
			$translate_x = 0;
			$translate_y = 0;
			$translate_z = 0;
			$rotate_x = 0;
			$rotate_y = 0;
			$rotate_z = 0;
			$geometry = 7;  // A toroid is the usual default BL 1 object
			$ratio = 0.05;  // Makes for a skinnier looking toroid, 0.1 is the default
			$color_a = 255; // Not needed since 255 is the default, but try making it smaller
			$topo = 3;  // A topo of 3 is the usual defautl for BL 21. This is the value you can change with the J key, too.
			$record_id = $id;  // This is used for db query, it corresponds to the variable passed to a php script using $_GET.
			
			// Here we define the outputstring again, now that we have changed some of the parameters
			$outputstring = "$id, $type, $data, $selected, $parent_id, $branch_level, $child_id, $child_index, $child_count, $ch_input_id, $ch_output_id, $ch_last_updated, $average, $interval, $aux_a_x, $aux_a_y, $aux_a_z, $aux_b_x, $aux_b_y, $aux_b_z, $color_shift, $rotate_vec_x, $rotate_vec_y, $rotate_vec_z, $rotate_vec_s, $scale_x, $scale_y, $scale_z, $translate_x, $translate_y, $translate_z, $tag_offset_x, $tag_offset_y, $tag_offset_z, $rotate_rate_x, $rotate_rate_y, $rotate_rate_z, $rotate_x, $rotate_y, $rotate_z, $scale_rate_x, $scale_rate_y, $scale_rate_z, $translate_rate_x, $translate_rate_y, $translate_rate_z, $translate_vec_x, $translate_vec_y, $translate_vec_z, $shader, $geometry, $line_width, $point_size, $ratio, $color_index, $colorvar, $color_a, $color_fade, $texture_id, $hide, $freeze, $topo, $facet, $auto_zoom_x, $auto_zoom_y, $auto_zoom_z, $trigger_hi_x, $trigger_hi_y, $trigger_hi_z, $trigger_lo_x, $trigger_lo_y, $trigger_lo_z, $set_hi_x, $set_hi_y, $set_hi_z, $set_lo_x, $set_lo_y, $set_lo_z, $proximity_x, $proximity_y, $proximity_z, $proximity_mode_x, $proximity_mode_y, $proximity_mode_z, $segments_x, $segments_y, $segments_z, $tag_mode, $format_id, $table_id, $record_id, $size\n";
			fwrite($fpout1, $outputstring);
			$tagtext = "i: ".$i." j: ".$j." k: ".$k;
			$tagstring = "$taginc,$record_id,0,\"$tagtext\",\"\"\n";
			$taginc++;
			fwrite($fptag1, $tagstring);
			
			//////////////////////////////////////////////////////////////////////////////////////////////////////
			// We loop through m representing my level1 objects, but BL 2 in Antz.
			for ($m = 0; $m < $numlevel1toroids; $m++) {  
				$id++;
				$data = $id;
				$parent_id = $level0object1id;
				$child_id = $id;
				$child_count = 0;
				$branch_level = 1;
				$translate_x = $m*360/$numlevel1toroids;  // This allows for evenly-distributed antz around the BL 1 toroid
				$translate_y = 0;
				$translate_z = 180;  // If the BL 2 geometry is a toroid, a value of 180 shifts it to intersect with its parent.
				$scale_x = 1;
				$scale_y = $scale_x;
				$scale_z = $scale_x;
				$topo = 3;
				$colorvar = $colortable[24];  // All BL 2 objects will be the same color
				$color_a = 255;
				$geometry = 7;
				$ratio = 0.1;
				$color_index = $m+1;
				$record_id = $id;
				$outputstring = "$id, $type, $data, $selected, $parent_id, $branch_level, $child_id, $child_index, $child_count, $ch_input_id, $ch_output_id, $ch_last_updated, $average, $interval, $aux_a_x, $aux_a_y, $aux_a_z, $aux_b_x, $aux_b_y, $aux_b_z, $color_shift, $rotate_vec_x, $rotate_vec_y, $rotate_vec_z, $rotate_vec_s, $scale_x, $scale_y, $scale_z, $translate_x, $translate_y, $translate_z, $tag_offset_x, $tag_offset_y, $tag_offset_z, $rotate_rate_x, $rotate_rate_y, $rotate_rate_z, $rotate_x, $rotate_y, $rotate_z, $scale_rate_x, $scale_rate_y, $scale_rate_z, $translate_rate_x, $translate_rate_y, $translate_rate_z, $translate_vec_x, $translate_vec_y, $translate_vec_z, $shader, $geometry, $line_width, $point_size, $ratio, $color_index, $colorvar, $color_a, $color_fade, $texture_id, $hide, $freeze, $topo, $facet, $auto_zoom_x, $auto_zoom_y, $auto_zoom_z, $trigger_hi_x, $trigger_hi_y, $trigger_hi_z, $trigger_lo_x, $trigger_lo_y, $trigger_lo_z, $set_hi_x, $set_hi_y, $set_hi_z, $set_lo_x, $set_lo_y, $set_lo_z, $proximity_x, $proximity_y, $proximity_z, $proximity_mode_x, $proximity_mode_y, $proximity_mode_z, $segments_x, $segments_y, $segments_z, $tag_mode, $format_id, $table_id, $record_id, $size\n";
				//echo $outputstring."<br />\n";
				$level1objectid = $id;
				fwrite($fpout1, $outputstring);
				$tagtext = "m: ".$m;
				$tagstring = "$taginc,$record_id,0,\"$tagtext\",\"\"\n";
				fwrite($fptag1, $tagstring);
				$taginc++;
				
				//////////////////////////////////////////////////////////////////////////////////////////////////////
				// We loop through n representing my level2 objects, but BL 3 in Antz.
				for ($n = 0; $n < $numlevel2toroids; $n++) {  
					$id++;
					$data = $id;
					$parent_id = $level1objectid;
					$child_id = $id;
					$child_count = 0;
					$branch_level = 1;
					$translate_x = $n*120/$numlevel2toroids;
					$translate_y = 0;
					$translate_z = 180;
					$scale_x = 1;
					$scale_y = $scale_x;
					$scale_z = $scale_x;
					$topo = 3;
					$color_index = $n + 1;
					$colortemp = round($n*sizeof($firecolortable)/$numlevel2toroids);  // Evenly distribute palette colors
					$colorvar = $firecolortable[$colortemp];
					$color_a = 255;
					$geometry = 7;
					$ratio = 0.08;
					$record_id = $id;
					$outputstring = "$id, $type, $data, $selected, $parent_id, $branch_level, $child_id, $child_index, $child_count, $ch_input_id, $ch_output_id, $ch_last_updated, $average, $interval, $aux_a_x, $aux_a_y, $aux_a_z, $aux_b_x, $aux_b_y, $aux_b_z, $color_shift, $rotate_vec_x, $rotate_vec_y, $rotate_vec_z, $rotate_vec_s, $scale_x, $scale_y, $scale_z, $translate_x, $translate_y, $translate_z, $tag_offset_x, $tag_offset_y, $tag_offset_z, $rotate_rate_x, $rotate_rate_y, $rotate_rate_z, $rotate_x, $rotate_y, $rotate_z, $scale_rate_x, $scale_rate_y, $scale_rate_z, $translate_rate_x, $translate_rate_y, $translate_rate_z, $translate_vec_x, $translate_vec_y, $translate_vec_z, $shader, $geometry, $line_width, $point_size, $ratio, $color_index, $colorvar, $color_a, $color_fade, $texture_id, $hide, $freeze, $topo, $facet, $auto_zoom_x, $auto_zoom_y, $auto_zoom_z, $trigger_hi_x, $trigger_hi_y, $trigger_hi_z, $trigger_lo_x, $trigger_lo_y, $trigger_lo_z, $set_hi_x, $set_hi_y, $set_hi_z, $set_lo_x, $set_lo_y, $set_lo_z, $proximity_x, $proximity_y, $proximity_z, $proximity_mode_x, $proximity_mode_y, $proximity_mode_z, $segments_x, $segments_y, $segments_z, $tag_mode, $format_id, $table_id, $record_id, $size\n";
					fwrite($fpout1, $outputstring);
					$tagtext = "n: ".$n;
					if ($DEBUG) echo "tagtext = $tagtext<br />";
					$tagstring = "$taginc,$record_id,0,\"$tagtext\",\"\"\n";
					fwrite($fptag1, $tagstring);
					$taginc++;
					$level2objectid = $id;
					for ($p = 0; $p < $numlevel3toroids; $p++) {  // This loop cycles through the 9 modalities
						$id++;
						$data = $id;
						$parent_id = $level2objectid;
						$child_id = $id;
						$translate_x = -30+$p*90/$numlevel3toroids;
						$translate_y = 0;
						$translate_z = 180;
						$scale_x = 1;
						$scale_y = $scale_x;
						$scale_z = $scale_x;
						$color_index = $p+1;
						$colortemp = round($p*sizeof($rainbowcolortable)/$numlevel3toroids);
						$colorvar = $rainbowcolortable[$colortemp];
						$color_a = 255;
						$topo = 3;
						$geometry = 7;
						$ratio = 0.1;
						$record_id = $id;
						$outputstring = "$id, $type, $data, $selected, $parent_id, $branch_level, $child_id, $child_index, $child_count, $ch_input_id, $ch_output_id, $ch_last_updated, $average, $interval, $aux_a_x, $aux_a_y, $aux_a_z, $aux_b_x, $aux_b_y, $aux_b_z, $color_shift, $rotate_vec_x, $rotate_vec_y, $rotate_vec_z, $rotate_vec_s, $scale_x, $scale_y, $scale_z, $translate_x, $translate_y, $translate_z, $tag_offset_x, $tag_offset_y, $tag_offset_z, $rotate_rate_x, $rotate_rate_y, $rotate_rate_z, $rotate_x, $rotate_y, $rotate_z, $scale_rate_x, $scale_rate_y, $scale_rate_z, $translate_rate_x, $translate_rate_y, $translate_rate_z, $translate_vec_x, $translate_vec_y, $translate_vec_z, $shader, $geometry, $line_width, $point_size, $ratio, $color_index, $colorvar, $color_a, $color_fade, $texture_id, $hide, $freeze, $topo, $facet, $auto_zoom_x, $auto_zoom_y, $auto_zoom_z, $trigger_hi_x, $trigger_hi_y, $trigger_hi_z, $trigger_lo_x, $trigger_lo_y, $trigger_lo_z, $set_hi_x, $set_hi_y, $set_hi_z, $set_lo_x, $set_lo_y, $set_lo_z, $proximity_x, $proximity_y, $proximity_z, $proximity_mode_x, $proximity_mode_y, $proximity_mode_z, $segments_x, $segments_y, $segments_z, $tag_mode, $format_id, $table_id, $record_id, $size\n";
						fwrite($fpout1, $outputstring);
						$tagtext = "p: ".$p;
						$tagstring = "$taginc,$record_id,0,\"$tagtext\",\"\"\n";
						fwrite($fptag1, $tagstring);
						$taginc++;
						$level3objectid = $id;
						for ($q = 0; $q < $numlevel4toroids; $q++) {
							$id++;
							$data = $id;
							$parent_id = $level3objectid;
							$child_id = $id;
							$translate_x = -30+$q*360/$numlevel4toroids;
							$translate_y = 0;
							$translate_z = 180;
							$scale_x = 1;
							$scale_y = $scale_x;
							$scale_z = $scale_x;
							$color_index = $q+1;
							$colortemp = round($q*sizeof($rainbowcolortable)/$numlevel4toroids);
							$colorvar = $rainbowcolortable[$colortemp];
							$color_a = 255;
							$topo = 3;
							$geometry = 7;
							$ratio = 0.1;
							$record_id = $id;
							$outputstring = "$id, $type, $data, $selected, $parent_id, $branch_level, $child_id, $child_index, $child_count, $ch_input_id, $ch_output_id, $ch_last_updated, $average, $interval, $aux_a_x, $aux_a_y, $aux_a_z, $aux_b_x, $aux_b_y, $aux_b_z, $color_shift, $rotate_vec_x, $rotate_vec_y, $rotate_vec_z, $rotate_vec_s, $scale_x, $scale_y, $scale_z, $translate_x, $translate_y, $translate_z, $tag_offset_x, $tag_offset_y, $tag_offset_z, $rotate_rate_x, $rotate_rate_y, $rotate_rate_z, $rotate_x, $rotate_y, $rotate_z, $scale_rate_x, $scale_rate_y, $scale_rate_z, $translate_rate_x, $translate_rate_y, $translate_rate_z, $translate_vec_x, $translate_vec_y, $translate_vec_z, $shader, $geometry, $line_width, $point_size, $ratio, $color_index, $colorvar, $color_a, $color_fade, $texture_id, $hide, $freeze, $topo, $facet, $auto_zoom_x, $auto_zoom_y, $auto_zoom_z, $trigger_hi_x, $trigger_hi_y, $trigger_hi_z, $trigger_lo_x, $trigger_lo_y, $trigger_lo_z, $set_hi_x, $set_hi_y, $set_hi_z, $set_lo_x, $set_lo_y, $set_lo_z, $proximity_x, $proximity_y, $proximity_z, $proximity_mode_x, $proximity_mode_y, $proximity_mode_z, $segments_x, $segments_y, $segments_z, $tag_mode, $format_id, $table_id, $record_id, $size\n";
							fwrite($fpout1, $outputstring);
							$tagtext = "q: ".$q;
							$tagstring = "$taginc,$record_id,0,\"$tagtext\",\"\"\n";
							fwrite($fptag1, $tagstring);
							$taginc++;
							$level4objectid = $id;
							for ($r = 0; $r < $numlevel5toroids; $r++) {
								$id++;
								$data = $id;
								$parent_id = $level4objectid;
								$child_id = $id;
								$translate_x = -30+$r*360/$numlevel5toroids;
								$translate_y = 0;
								$translate_z = 180;
								$scale_x = 1;
								$scale_y = $scale_x;
								$scale_z = $scale_x;
								$color_index = $r+1;
								$colortemp = round($r*sizeof($colortable)/$numlevel5toroids);
								$colorvar = $colortable[$colortemp];
								$color_a = 255;
								$topo = 3;
								$geometry = 7;
								$ratio = 0.1;
								$record_id = $id;
								$outputstring = "$id, $type, $data, $selected, $parent_id, $branch_level, $child_id, $child_index, $child_count, $ch_input_id, $ch_output_id, $ch_last_updated, $average, $interval, $aux_a_x, $aux_a_y, $aux_a_z, $aux_b_x, $aux_b_y, $aux_b_z, $color_shift, $rotate_vec_x, $rotate_vec_y, $rotate_vec_z, $rotate_vec_s, $scale_x, $scale_y, $scale_z, $translate_x, $translate_y, $translate_z, $tag_offset_x, $tag_offset_y, $tag_offset_z, $rotate_rate_x, $rotate_rate_y, $rotate_rate_z, $rotate_x, $rotate_y, $rotate_z, $scale_rate_x, $scale_rate_y, $scale_rate_z, $translate_rate_x, $translate_rate_y, $translate_rate_z, $translate_vec_x, $translate_vec_y, $translate_vec_z, $shader, $geometry, $line_width, $point_size, $ratio, $color_index, $colorvar, $color_a, $color_fade, $texture_id, $hide, $freeze, $topo, $facet, $auto_zoom_x, $auto_zoom_y, $auto_zoom_z, $trigger_hi_x, $trigger_hi_y, $trigger_hi_z, $trigger_lo_x, $trigger_lo_y, $trigger_lo_z, $set_hi_x, $set_hi_y, $set_hi_z, $set_lo_x, $set_lo_y, $set_lo_z, $proximity_x, $proximity_y, $proximity_z, $proximity_mode_x, $proximity_mode_y, $proximity_mode_z, $segments_x, $segments_y, $segments_z, $tag_mode, $format_id, $table_id, $record_id, $size\n";
								fwrite($fpout1, $outputstring);
								$tagtext = "r: ".$r;
								$tagstring = "$taginc,$record_id,0,\"$tagtext\",\"\"\n";
								fwrite($fptag1, $tagstring);
								$taginc++;
								$level5objectid = $id;
							} // end for r
						} // end for q
					} // end for p
				} // end for n
			} // end for m
		} // end for k
	} // end for j
} // end for i

fclose($fpout1);

$outputpngfile = "antzmaps/map00002.jpg";
//imagepng($im, $outputpngfile);
//imagedestroy($im);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This function creates a compressed zip file containing all the necessary files for Dave to demo 

function create_zip($files = array(),$destination = '',$overwrite = false) {
  //if the zip file already exists and overwrite is false, return false
  if(file_exists($destination) && !$overwrite) { return false; }
  //vars
  $valid_files = array();
  //if files were passed in...
  if(is_array($files)) {
    //cycle through each file
    foreach($files as $file) {
      //make sure the file exists
      if(file_exists($file)) {
        $valid_files[] = $file;
      }
    }
  }
  //if we have good files...
  if(count($valid_files)) {
    //create the archive
    $zip = new ZipArchive();
    if($zip->open($destination,$overwrite ? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE) !== true) {
      return false;
    }
    //add the files
    foreach($valid_files as $file) {
      $zip->addFile($file,$file);
    }
    //debug
    //echo 'The zip archive contains ',$zip->numFiles,' files with a status of ',$zip->status;
    
    //close the zip -- done!
    $zip->close();
    
    //check to make sure the file exists
    return file_exists($destination);
  }
  else
  {
    return false;
  }
}

$zipfilename = $outputfileprefix.".zip";
$files_to_zip = array(
  'antzmaps/map00001.jpg',
  'antz_b.exe',
  $outputfile,
  $batfile,
  'glut32.dll',
  'freeglut.dll'
);

//if true, good; if false, zip creation failed
$result = create_zip($files_to_zip,$zipfilename);

echo "<br /><br /><a href=\"$outputfile\">Download $outputfile file.</a><br /><br /><br />\n";
echo "<br /><br /><a href=\"$zipfilename\">Download $zipfilename ZIP file.</a><br /><br /><br />\n";


?>

</body>
</html>
